# pydantic-argparse-next

Argument parser based on pydantic v2.

### Install:

```bash
pip install pydantic-argparse-next
```

### Supports:

✅ Positional arguments

        ✅ Required positional arguments

        ✅ Optional positional arguments

✅ Keyword arguments

        ✅ Required keyword arguments

        ✅ Optional keyword arguments

✅ Subcommands

        ✅ Required subcommands

        ✅ Optional subcommands

        ✅ Subcommands within subcommands

✅ Actions

        ✅ Choice (And simple text and Enum object)

        ✅ Store True

        ✅ Store False

        ✅ Variadic arguments

⬜ Extra

        ⬜ Easy saving config to file

        ⬜ Easy load config from file

### Docs and examples:

1. [Base usage](https://github.com/overgodofchaos/pydantic-argparse-next/blob/main/docs/BaseUsage.md)

2. Actions
   
   1. [Choice](https://github.com/overgodofchaos/pydantic-argparse-next/blob/main/docs/Choice.md)
   
   2. [Store True and Store False](https://github.com/overgodofchaos/pydantic-argparse-next/blob/main/docs/StoreTrueFalse.md)
   
   3. [Subcommands](https://github.com/overgodofchaos/pydantic-argparse-next/blob/main/docs/Subcommands.md)
   
   4. [Variadic](https://github.com/overgodofchaos/pydantic-argparse-next/blob/main/docs/Variadic.md)
